diff -r 1d1c4c997b66 sys/netinet/tcp_subr.c
--- a/sys/netinet/tcp_subr.c	Tue Jul 07 20:31:09 2015 +0000
+++ b/sys/netinet/tcp_subr.c	Sun Aug 30 14:27:42 2015 +1000
@@ -42,9 +42,12 @@
 #include <sys/systm.h>
 #include <sys/callout.h>
 #include <sys/hhook.h>
+#include <sys/kdb.h>
 #include <sys/kernel.h>
 #include <sys/khelp.h>
+#include <sys/limits.h>
 #include <sys/sysctl.h>
+#include <sys/taskqueue.h>
 #include <sys/jail.h>
 #include <sys/malloc.h>
 #include <sys/mbuf.h>
@@ -53,6 +56,7 @@
 #endif
 #include <sys/priv.h>
 #include <sys/proc.h>
+#include <sys/queue.h>
 #include <sys/sdt.h>
 #include <sys/socket.h>
 #include <sys/socketvar.h>
@@ -92,6 +96,9 @@
 #include <netinet6/tcp6_var.h>
 #endif
 #include <netinet/tcpip.h>
+#include <netinet/mptcp_var.h>
+#include <netinet/mptcp_pcb.h>
+#include <crypto/sha1.h>
 #ifdef TCPDEBUG
 #include <netinet/tcp_debug.h>
 #endif
@@ -166,6 +173,11 @@
    "Default TCP Maximum Segment Size for IPv6");
 #endif /* INET6 */
 
+VNET_DEFINE(unsigned int, tcp_override_isn) = 0;
+SYSCTL_UINT(_net_inet_tcp, OID_AUTO, override_isn, CTLFLAG_RW,
+    &VNET_NAME(tcp_override_isn), 0,
+    "Manually set the initial sequence number of TCP flows");
+
 /*
  * Minimum MSS we accept and use. This prevents DoS attacks where
  * we are forced to a ridiculous low MSS like 20 and send hundreds
@@ -215,6 +227,12 @@
 SYSCTL_INT(_net_inet_tcp, OID_AUTO, soreceive_stream, CTLFLAG_RDTUN,
     &tcp_soreceive_stream, 0, "Using soreceive_stream for TCP sockets");
 
+VNET_DEFINE(int, tcp_do_mptcp) = 1;
+SYSCTL_INT(_net_inet_tcp, OID_AUTO, mptcp, CTLFLAG_RW,
+    &VNET_NAME(tcp_do_mptcp), 0,
+    "Enable Multipath Support");
+
+
 #ifdef TCP_SIGNATURE
 static int	tcp_sig_checksigs = 1;
 SYSCTL_INT(_net_inet_tcp, OID_AUTO, signature_verify_input, CTLFLAG_RW,
@@ -373,6 +391,10 @@
 	uma_zone_set_max(V_tcpcb_zone, maxsockets);
 	uma_zone_set_warning(V_tcpcb_zone, "kern.ipc.maxsockets limit reached");
 
+	/* mptcp init */
+	mpp_init();
+	mp_init();
+
 	tcp_tw_init();
 	syncache_init();
 	tcp_hc_init();
@@ -436,6 +458,8 @@
 	syncache_destroy();
 	tcp_tw_destroy();
 	in_pcbinfo_destroy(&V_tcbinfo);
+	mp_destroy();
+
 	uma_zdestroy(V_sack_hole_zone);
 	uma_zdestroy(V_tcpcb_zone);
 
@@ -809,6 +833,10 @@
 	in_pcbref(inp);	/* Reference for tcpcb */
 	tp->t_inpcb = inp;
 
+	/* dss map queue */
+	TAILQ_INIT(&tp->t_send_maps.dsmap_list);
+	TAILQ_INIT(&tp->t_rcv_maps.dsmap_list);
+
 	/*
 	 * Init srtt to TCPTV_SRTTBASE (0), so we can tell that we have no
 	 * rtt estimate.  Set rttvar so that srtt + 4 * rttvar gives
@@ -827,8 +855,36 @@
 	 * which may match an IPv4-mapped IPv6 address.
 	 */
 	inp->inp_ip_ttl = V_ip_defttl;
-	inp->inp_ppcb = tp;
-	return (tp);		/* XXX */
+	inp->inp_ppcb = tp;	/* XXX */
+	return (tp);
+}
+
+/* The mappings always start from beginning of the send buffer, and the
+ * maps are placed into the list in sequence order. */
+void
+dsmap_drop(struct dsmapq_head *dsmap_list, tcp_seq th_ack, int len)
+{
+	struct ds_map *map;
+
+    map = TAILQ_FIRST(dsmap_list);
+    while (len > 0) {
+    	KASSERT(map != NULL, ("%s: no send map, len %d", __func__, len));
+    	KASSERT(map->ds_map_remain >= len || TAILQ_NEXT(map, sf_ds_map_next),
+    	        ("%s: drop len %d greater than mapped bytes\n", __func__, len));
+
+		if (map->ds_map_remain > len) {
+			map->ds_map_remain -= len;
+			//map->sf_seq_start = th_ack;
+			break;
+		}
+		len -= map->ds_map_remain;
+
+		struct ds_map *n;
+		n = TAILQ_NEXT(map, sf_ds_map_next);
+		TAILQ_REMOVE(dsmap_list, map, sf_ds_map_next);
+		free(map, M_DSSMAP);
+		map = n;
+	}
 }
 
 /*
@@ -895,6 +951,55 @@
 }
 
 /*
+ * Switch CC algorithm to the passed-in algorithm. Should verify that the algo
+ * exists and the module is loaded before calling this function.
+ *
+ * XXXNJW: Not sure what happens in terms of the new algo initialising in
+ * 'slow-start' phase or similar. Perhaps the algorithms will sort themselves
+ * out using the data passed in by cc_var.
+ */
+//int
+//tcp_ccalgoswitch(struct cc_algo *new_algo, struct tcpcb *tp)
+//{
+//    struct inpcb *inp = tp->t_inpcb;
+//    struct cc_algo *old_algo;
+//    struct cc_var new_ccv;
+//
+//    INP_WLOCK(inp);
+//
+//    if (!(inp->inp_flags & INP_TIMEWAIT)) {
+//    	old_algo = CC_ALGO(tp);
+//
+//    	/* Attempt to initialise the new algorithm before switching. Failure
+//    	 * to initialise cc_data for the new CC algorithm will result in
+//    	 * returning with the original CC algorithm still configured. */
+//		if (new_algo->cb_init != NULL) {
+//			if (new_algo->cb_init(&new_ccv) > 0) {
+//				INP_WUNLOCK(inp);
+//				return ENOMEM;
+//			}
+//
+//			/* Remove any memory allocated by the previous CC algorithm. This
+//			 * ONLY clears memory pointed to by cc_data in the cc_var struct.
+//			 * i.e. all other ccv data will stay the same.
+//			 */
+//			if (old_algo->cb_destroy != NULL)
+//				old_algo->cb_destroy(tp->ccv);
+//
+//			/* Set pointer to newly initialised cc_data */
+//			tp->ccv->cc_data = new_ccv.cc_data;
+//		}
+//
+//		/* Switch over to the new algorithm */
+//		CC_ALGO(tp) = new_algo;
+//    }
+//
+//    INP_WUNLOCK(inp);
+//
+//    return 0;
+//}
+
+/*
  * Drop a TCP connection, reporting
  * the specified error.  If connection is synchronized,
  * then send a RST to peer.
@@ -1001,9 +1106,21 @@
 		tcp_hc_update(&inp->inp_inc, &metrics);
 	}
 
-	/* free the reassembly queue, if any */
+	/* free the reassembly queue, if any
+	 * XXXNJW: If a subflow has called into tcp_discard, could we still need
+	 * to retain the segments, in cases where there is some disorder and these
+	 * segments will be needed to reassemble later? */
 	tcp_reass_flush(tp);
 
+	/* free ds_maps from t_rxmaps */
+	struct ds_map *n1, *n2;
+	n1 = TAILQ_FIRST(&tp->t_rcv_maps.dsmap_list);
+    while (n1 != NULL) {
+            n2 = TAILQ_NEXT(n1, sf_ds_map_next);
+            free(n1, M_DSSMAP);
+            n1 = n2;
+    }
+
 #ifdef TCP_OFFLOAD
 	/* Disconnect offload device, if any. */
 	if (tp->t_flags & TF_TOE)
diff -r 1d1c4c997b66 sys/netinet/tcp_syncache.c
--- a/sys/netinet/tcp_syncache.c	Tue Jul 07 20:31:09 2015 +0000
+++ b/sys/netinet/tcp_syncache.c	Sun Aug 30 14:27:42 2015 +1000
@@ -41,6 +41,7 @@
 #include <sys/param.h>
 #include <sys/systm.h>
 #include <sys/kernel.h>
+#include <sys/endian.h>
 #include <sys/sysctl.h>
 #include <sys/limits.h>
 #include <sys/lock.h>
@@ -53,6 +54,7 @@
 #include <sys/socketvar.h>
 #include <sys/syslog.h>
 #include <sys/ucred.h>
+#include <sys/queue.h>
 
 #include <sys/md5.h>
 #include <crypto/siphash/siphash.h>
@@ -78,12 +80,19 @@
 #include <netinet6/ip6_var.h>
 #include <netinet6/in6_pcb.h>
 #endif
+
+
 #include <netinet/tcp.h>
 #include <netinet/tcp_fsm.h>
 #include <netinet/tcp_seq.h>
 #include <netinet/tcp_timer.h>
 #include <netinet/tcp_var.h>
 #include <netinet/tcp_syncache.h>
+
+#include <netinet/mptcp.h>
+#include <netinet/mptcp_var.h>
+#include <netinet/mptcp_pcb.h>
+
 #ifdef INET6
 #include <netinet6/tcp6_var.h>
 #endif
@@ -211,6 +220,9 @@
 #define	SCH_UNLOCK(sch)		mtx_unlock(&(sch)->sch_mtx)
 #define	SCH_LOCK_ASSERT(sch)	mtx_assert(&(sch)->sch_mtx, MA_OWNED)
 
+#define lsototcpcb(lso) intotcpcb(((struct mpcb *)mpptompcb((struct mppcb *) \
+     sotomppcb(lso)))->m_cb_ref.inp)
+
 /*
  * Requires the syncache entry to be already removed from the bucket list.
  */
@@ -661,15 +673,25 @@
 	struct tcpcb *tp;
 	int error;
 	char *s;
+//	struct mppcb *l_mpp;
+	struct mppcb *mpp;
+	struct mpcb *mp;
+    struct socket *sf_so = NULL;
 
 	INP_INFO_WLOCK_ASSERT(&V_tcbinfo);
 
+//	l_mpp = sotomppcb(lso);
+//	MPP_LOCK_ASSERT(l_mpp);
+
 	/*
 	 * Ok, create the full blown connection, and set things up
 	 * as they would have been set up if we had created the
 	 * connection when the SYN arrived.  If we can't create
 	 * the connection, abort it.
 	 */
+	// XXXNJW: Calling sonewconn should be done with the MPP lock held. At this
+	// a usrreq might be called that tries to manipulate the socket or the MPP
+	// in some way.
 	so = sonewconn(lso, 0);
 	if (so == NULL) {
 		/*
@@ -686,6 +708,74 @@
 		}
 		goto abort2;
 	}
+
+	// at this point so is a duplicate of the listen socket. need to duplicate
+	// the mpcb fields from syncache mptcp fields to the new mpcb
+    // causes a bunch of witness LOR warnings, but shouldn't be a problem as
+	// the mpp and mp are held under the INP_WLOCK of an inp attached to a
+	// different mpcb
+
+	// should put the mppcb socket into "acceptconn" state, so that when the
+	// subflow triggers a "subflow_connected" event (on return to
+	// tcp_input), the mppcb socket also calls soisconencted in response,
+	// which leads to a wakeup of head->so_timeo, and the mppcb socket being
+	// dequeued from so_comp and "accept" being called on the mppcb socket.
+	// at this point the fd for the newly created mppcb socket will be
+	// returned to the process, and the process can start writing/receiving
+	// data on the new (MPTCP) socket.
+
+	// The following creates a LOR with the INP_INFO_WLOCK. Will need to do
+	// some un-locking/re-locking to make sure that the ordering is correct
+	// (TODO).
+
+	mpp = sotomppcb(so);
+	MPP_LOCK(mpp);
+    mp = mpptompcb(mpp);
+
+    /* Copy sequence numbers from the syncache. These are over-ridden
+     * if the connection transitions into MP */
+    //    mp_syncache_newmpcb(mp, sc);
+    mp->ds_rcv_nxt = sc->sc_irs + 1;
+    mp->ds_snd_una = mp->ds_map_max = mp->ds_map_min = mp->ds_snd_nxt =
+        sc->sc_iss + 1;
+    mp->mp_passive = 1;
+
+    /* create a socket for a new subflow */
+    error = mp_create_subflow_socket(so, &sf_so);
+	if (error) {
+		MPP_UNLOCK(mpp);
+		goto abort2;
+	}
+	KASSERT(sf_so != NULL, ("%s: subflow socket NULL", __func__));
+
+	/* Must mark the primary socket as connecting while waiting for the subflow
+	 * socket to reach connected and trigger a connected event. the primary
+     * socket will then call soisconnected and alloc a new fd for the process
+     * to use. */
+    if (!error)
+    	soisconnecting(so);
+
+    /* If an MP_CAPABLE exchange was made, enable MPTCP now. */
+//    if (sc->sc_mp_flags & MPF_MP_CAPABLE_ACK) {
+//    	sc->sc_mp_flags &= ~MPF_MP_CAPABLE_ACK;
+//    	soisconnected(so);
+//    	mp_init_established(mp);
+//    }
+
+	/* attach a tcpcb and inpcb to the subflow socket */
+	error = mp_attach_subflow(sf_so);
+
+	/* Insert the new sufblow pcbs and gso into sf_list */
+	error = mp_insert_subflow(mp, sf_so);
+
+    MPP_UNLOCK(mpp);
+
+	if (error)
+		goto abort2;
+
+    /* from here on work with the subflow socket */
+    so = sf_so;
+
 #ifdef MAC
 	mac_socketpeer_set_from_mbuf(m, so);
 #endif
@@ -846,9 +936,23 @@
 	tp->rcv_adv += tp->rcv_wnd;
 	tp->last_ack_sent = tp->rcv_nxt;
 
-	tp->t_flags = sototcpcb(lso)->t_flags & (TF_NOPUSH|TF_NODELAY);
-	if (sc->sc_flags & SCF_NOOPT)
+	/* Will be copied to mpcb when mp_init_establish is called */
+	if (sc->sc_mp_flags & MPF_MP_CAPABLE_ACK) {
+		sc->sc_mp_flags &= ~MPF_MP_CAPABLE_ACK;
+		tp->t_mp_conn.local_key = sc->sc_local_key;
+		tp->t_mp_conn.remote_key = sc->sc_remote_key;
+		tp->t_mp_conn.local_token = sc->sc_mp_local_token;
+		tp->t_mp_conn.remote_token = sc->sc_mp_remote_token;
+		tp->t_mp_conn.ds_idss = sc->sc_ds_iss;
+		tp->t_mp_conn.ds_idrs = sc->sc_ds_irs;
+	}
+
+	//tp->t_flags = sototcpcb(lso)->t_flags & (TF_NOPUSH|TF_NODELAY);
+	tp->t_flags = lsototcpcb(lso)->t_flags & (TF_NOPUSH|TF_NODELAY);
+
+	if (sc->sc_flags & SCF_NOOPT) {
 		tp->t_flags |= TF_NOOPT;
+	}
 	else {
 		if (sc->sc_flags & SCF_WINSCALE) {
 			tp->t_flags |= TF_REQ_SCALE|TF_RCVD_SCALE;
@@ -901,15 +1005,18 @@
 	/*
 	 * Copy and activate timers.
 	 */
-	tp->t_keepinit = sototcpcb(lso)->t_keepinit;
-	tp->t_keepidle = sototcpcb(lso)->t_keepidle;
-	tp->t_keepintvl = sototcpcb(lso)->t_keepintvl;
-	tp->t_keepcnt = sototcpcb(lso)->t_keepcnt;
+	tp->t_keepinit = lsototcpcb(lso)->t_keepinit;
+	tp->t_keepidle = lsototcpcb(lso)->t_keepidle;
+	tp->t_keepintvl = lsototcpcb(lso)->t_keepintvl;
+	tp->t_keepcnt = lsototcpcb(lso)->t_keepcnt;
 	tcp_timer_activate(tp, TT_KEEP, TP_KEEPINIT(tp));
 
 	INP_WUNLOCK(inp);
 
-	soisconnected(so);
+	soisconnected(so); // XXXNJW: do we need this? the tcpcb returns in SYN_RECEIVED
+	                   // so the transport isn't actually connected at this point.
+	                   // and tcp_do_segment will mark the socket as connected once
+	                   // we hit the ACK_processing switch block.
 
 	TCPSTAT_INC(tcps_accepts);
 	return (so);
@@ -1061,6 +1168,9 @@
 		goto failed;
 	}
 
+	if (to->to_mopts.mpo_flags & MPOF_CAPABLE_ACK)
+		sc->sc_mp_flags |= MPF_MP_CAPABLE_ACK;
+
 	*lsop = syncache_socket(sc, *lsop, m);
 
 	if (*lsop == NULL)
@@ -1125,7 +1235,7 @@
 	 * soon as possible.
 	 */
 	so = *lsop;
-	tp = sototcpcb(so);
+	tp = lsototcpcb(so);
 	cred = crhold(so->so_cred);
 
 #ifdef INET6
@@ -1267,7 +1377,7 @@
 	sc->sc_todctx = todctx;
 #endif
 	sc->sc_irs = th->th_seq;
-	sc->sc_iss = arc4random();
+	sc->sc_iss = V_tcp_override_isn > 0 ? V_tcp_override_isn : arc4random();
 	sc->sc_flags = 0;
 	sc->sc_flowlabel = 0;
 
@@ -1330,6 +1440,26 @@
 	if (to->to_flags & TOF_SIGNATURE || ltflags & TF_SIGNATURE)
 		sc->sc_flags |= SCF_SIGNATURE;
 #endif
+
+	/* Set to 1 if we send an MP_CAPABLE option */
+	sc->sent_capable = 0;
+
+	/*
+	 * MP SYN packets are either the start of a new connection
+	 * (MP_CAPABLE) or the addition of a subflow to an existing
+	 * connection (MP_JOIN).
+	 */
+	if (to->to_flags & TOF_MPTCP) {
+		if(to->to_mopts.mpo_flags & MPOF_MP_CAPABLE) {
+			sc->sc_flags |= SCF_MPTCP;
+			sc->sc_mp_flags |= MPF_MP_CAPABLE;
+			mp_syncache_process_remote_key(sc, to->to_mopts.remote_key);
+			mp_syncache_process_local_key(sc);
+			if (to->to_mopts.mpo_flags & MPOF_USE_CSUM)
+				sc->csum_enabled = 1;
+		} /* removed an else-if for MP_JOINs */
+	}
+
 	if (to->to_flags & TOF_SACKPERM)
 		sc->sc_flags |= SCF_SACK;
 	if (to->to_flags & TOF_MSS)
@@ -1504,6 +1634,19 @@
 			to.to_tsecr = sc->sc_tsreflect;
 			to.to_flags |= TOF_TS;
 		}
+		if(sc->sc_flags & SCF_MPTCP) {
+			to.to_mopts.mpo_flags = 0;
+			/* Got a SYN with MP_CAPABLE, so send MP_CAPABLE back */
+			if(sc->sc_mp_flags & MPF_MP_CAPABLE) {
+				to.to_flags |= TOF_MPTCP;
+				to.to_mopts.mpo_flags |=
+						MPOF_CAPABLE_SYN;
+				to.to_mopts.local_key = sc->sc_local_key;
+
+				if (sc->csum_enabled)
+					to.to_mopts.mpo_flags |= MPOF_USE_CSUM;
+			}
+		}
 		if (sc->sc_flags & SCF_SACK)
 			to.to_flags |= TOF_SACKPERM;
 #ifdef TCP_SIGNATURE
@@ -1531,8 +1674,15 @@
 			}
 		}
 #endif
+		uint64_t mpof_flags = to.to_mopts.mpo_flags;
 		optlen = tcp_addoptions(&to, (u_char *)(th + 1));
 
+		/* If mp_capable was set and is now unset, then it has
+		 * been added as an option on the outgoing SYN/ACK */
+		if ((mpof_flags & MPOF_CAPABLE_SYN) &&
+		    (!to.to_mopts.mpo_flags & MPOF_CAPABLE_SYN))
+			sc->sent_capable = 1;
+
 		/* Adjust headers by option size. */
 		th->th_off = (sizeof(struct tcphdr) + optlen) >> 2;
 		m->m_len += optlen;
@@ -2043,3 +2193,29 @@
 	*pcbs_exported = count;
 	return error;
 }
+
+/* Find inp matching addresses and return locked */
+static inline struct inpcb*
+inp_lookup(struct in_addr *faddr, struct in_addr *laddr, uint16_t fport,
+    uint16_t lport) {
+	struct inpcb *inp = NULL;
+	struct tcpcb *tp = NULL;
+
+	INP_INFO_LOCK_ASSERT(&V_tcbinfo);
+	LIST_FOREACH(inp, &V_tcb, inp_list) {
+		INP_WLOCK(inp);
+		/* Important to skip tcptw structs. */
+		if (!(inp->inp_flags & INP_TIMEWAIT) &&
+			(tp = intotcpcb(inp)) != NULL) {
+				if (inp->inp_faddr.s_addr == faddr->s_addr &&
+					inp->inp_laddr.s_addr == laddr->s_addr &&
+					inp->inp_fport == fport &&
+					inp->inp_lport == lport) {
+					break;
+				}
+		}
+		INP_WUNLOCK(inp);
+	}
+
+	return(inp);
+}
diff -r 1d1c4c997b66 sys/netinet/tcp_syncache.h
--- a/sys/netinet/tcp_syncache.h	Tue Jul 07 20:31:09 2015 +0000
+++ b/sys/netinet/tcp_syncache.h	Sun Aug 30 14:27:42 2015 +1000
@@ -41,6 +41,8 @@
 void	 syncache_unreach(struct in_conninfo *, struct tcphdr *);
 int	 syncache_expand(struct in_conninfo *, struct tcpopt *,
 	     struct tcphdr *, struct socket **, struct mbuf *);
+int	 syncache_expand_subflow(struct in_conninfo *, struct tcpopt *,
+	     struct tcphdr *, struct socket **, struct mbuf *);
 void	 syncache_add(struct in_conninfo *, struct tcpopt *,
 	     struct tcphdr *, struct inpcb *, struct socket **, struct mbuf *,
 	     void *, void *);
@@ -77,6 +79,25 @@
 
 	void		*sc_pspare;		/* TCP_SIGNATURE */
 	u_int32_t	sc_spare[2];		/* UTO */
+
+/* MULTIPATH TCP */
+	uint64_t	sc_ds_iss;		/* initial data sequence num */
+	uint64_t	sc_ds_irs;		/* initial receive sequence num */
+	u_int64_t	sc_remote_key;
+	u_int64_t	sc_local_key;
+	uint32_t 	sc_local_rand;	/* random number for join MAC */
+	uint32_t 	sc_remote_rand;	/* random number for join MAC */
+	uint32_t	sc_mp_remote_token;	/* token for the multipath session */
+	uint32_t	sc_mp_local_token;	/* token for the multipath session */
+
+	uint8_t sc_hmac_local[20];	/* MP_JOIN handshakes use HMACs to ensure */
+	uint8_t sc_hmac_remote[20];	/* that a subflow belongs to connection */
+	char* 	sc_sentmac_ptr;		/* points to HMAC sent in mp_join ACK*/
+
+	uint8_t sent_capable:1,		/* sent mp_cable */
+			csum_enabled:1;
+	uint8_t	sc_mp_flags;		/* flags for mp subtype */
+	struct	mpcb *t_mpcb;		/* pointer to multipath cb */
 };
 
 /*
@@ -88,9 +109,20 @@
 						/* MSS is implicit */
 #define SCF_UNREACH	0x10			/* icmp unreachable received */
 #define SCF_SIGNATURE	0x20			/* send MD5 digests */
+#define	SCF_MPTCP	0x40			/* MPTCP capable */
 #define SCF_SACK	0x80			/* send SACK option */
 #define SCF_ECN		0x100			/* send ECN setup packet */
 
+#define	SYNCOOKIE_SECRET_SIZE	16
+#define	SYNCOOKIE_LIFETIME	15		/* seconds */
+
+/*
+ * Flags for sc_mp_flags
+ */
+#define MPF_MP_CAPABLE	    0x01
+#define MPF_MP_CAPABLE_ACK	0x02
+#define MPF_MP_JOIN		    0x04
+
 struct syncache_head {
 	struct mtx	sch_mtx;
 	TAILQ_HEAD(sch_head, syncache)	sch_bucket;
@@ -100,9 +132,6 @@
 	struct tcp_syncache *sch_sc;
 };
 
-#define	SYNCOOKIE_SECRET_SIZE	16
-#define	SYNCOOKIE_LIFETIME	15		/* seconds */
-
 struct syncookie_secret {
 	volatile u_int oddeven;
 	uint8_t key[2][SYNCOOKIE_SECRET_SIZE];
diff -r 1d1c4c997b66 sys/netinet/tcp_timer.c
--- a/sys/netinet/tcp_timer.c	Tue Jul 07 20:31:09 2015 +0000
+++ b/sys/netinet/tcp_timer.c	Sun Aug 30 14:27:42 2015 +1000
@@ -48,6 +48,7 @@
 #include <sys/socketvar.h>
 #include <sys/sysctl.h>
 #include <sys/systm.h>
+#include <sys/taskqueue.h>
 
 #include <net/if.h>
 #include <net/route.h>
@@ -71,6 +72,8 @@
 #include <netinet6/tcp6_var.h>
 #endif
 #include <netinet/tcpip.h>
+#include <netinet/mptcp_var.h>
+#include <netinet/mptcp_pcb.h>
 #ifdef TCPDEBUG
 #include <netinet/tcp_debug.h>
 #endif
@@ -179,6 +182,22 @@
     "Path MTU Discovery IPv6 Black Hole Detection lowered MSS");
 #endif
 
+/* MPTCP */
+VNET_DECLARE(int, mpsubflowrexmits);
+#define	V_mpsubflowrexmits  VNET(mpsubflowrexmits)
+VNET_DEFINE(int, mpsubflowrexmits) = 8;
+SYSCTL_INT(_net_inet_tcp, OID_AUTO, mpsubflowrexmits,
+	CTLFLAG_VNET | CTLFLAG_RW, &VNET_NAME(mpsubflowrexmits), 0,
+    "MPTCP - Max number of subflow-level rexmits");
+
+VNET_DECLARE(int, mprexmittrigger);
+#define	V_mprexmittrigger  VNET(mprexmittrigger)
+VNET_DEFINE(int, mprexmittrigger) = 3;
+SYSCTL_INT(_net_inet_tcp, OID_AUTO, mprexmittrigger,
+	CTLFLAG_VNET | CTLFLAG_RW, &VNET_NAME(mprexmittrigger), 0,
+    "MPTCP - RTO count to trigger data-level rexmit");
+
+
 #ifdef	RSS
 static int	per_cpu_timers = 1;
 #else
@@ -549,9 +568,13 @@
 {
 	struct tcpcb *tp = xtp;
 	CURVNET_SET(tp->t_vnet);
+	struct mpcb *mp = tp->t_mpcb;
 	int rexmt;
 	int headlocked;
 	struct inpcb *inp;
+	uint64_t mp_rexmit_dsn;
+	int mp_rexmt = 0;
+
 #ifdef TCPDEBUG
 	int ostate;
 
@@ -585,8 +608,21 @@
 	 * Retransmission timer went off.  Message has not
 	 * been acked within retransmit interval.  Back off
 	 * to a longer retransmit interval and retransmit one segment.
+	 *
+	 * XXXNJW: added a (temporary) way to kill a retansmitting TCP
+	 * if we are using multipath. Should really be checking subflow
+	 * count however, as this will disconnect a single-subflow MPTCP
+	 * connection after rxtshift hits mpsubflowrexmits
 	 */
-	if (++tp->t_rxtshift > TCP_MAXRXTSHIFT) {
+	if (++tp->t_rxtshift > TCP_MAXRXTSHIFT ||
+	       ((tp->t_sf_state & SFS_MP_ENABLED) &&
+	       (tp->t_rxtshift == V_mpsubflowrexmits))) {
+
+		if (tp->t_sf_state & SFS_MP_ENABLED)
+			tp->t_sf_state |= SFS_MP_DISCONNECTED;
+
+		printf("%s: drop tp %p, sf state %d\n", __func__, tp, tp->t_sf_state);
+
 		tp->t_rxtshift = TCP_MAXRXTSHIFT;
 		TCPSTAT_INC(tcps_timeoutdrop);
 		in_pcbref(inp);
@@ -611,8 +647,10 @@
 		headlocked = 1;
 		goto out;
 	}
+
 	INP_INFO_RUNLOCK(&V_tcbinfo);
 	headlocked = 0;
+
 	if (tp->t_state == TCPS_SYN_SENT) {
 		/*
 		 * If the SYN was retransmitted, indicate CWND to be
@@ -779,6 +817,23 @@
 		tp->t_rttvar += (tp->t_srtt >> TCP_RTT_SHIFT);
 		tp->t_srtt = 0;
 	}
+
+	/*
+	 * After V_mprexmittrigger RTOs firing, re-inject the outstanding data.
+	 */
+	// triggered only once. all un-acked segments are enqueued at this time.
+	if (tp->t_state == TCPS_ESTABLISHED && (tp->t_sf_state & SFS_MP_ENABLED)
+		&& tp->t_rxtshift == V_mprexmittrigger) {
+		int map_offset;
+		struct ds_map *snd_dsmap = mp_find_dsmap(tp, tp->snd_nxt);
+		if (snd_dsmap != NULL) {
+			mp_rexmt = 1;
+   			map_offset = tp->snd_nxt - snd_dsmap->sf_seq_start;
+            mp_rexmit_dsn = snd_dsmap->ds_map_start + map_offset;
+		}
+	}
+
+
 	tp->snd_nxt = tp->snd_una;
 	tp->snd_recover = tp->snd_max;
 	/*
@@ -804,6 +859,24 @@
 		INP_WUNLOCK(inp);
 	if (headlocked)
 		INP_INFO_WUNLOCK(&V_tcbinfo);
+
+	/* Subflow has triggered multiple RTOs. Take the data-level
+	 * offset and resend via mp_output. mp_rexmt is only set when
+	 * we have a valid tp */
+	if (tp != NULL && mp_rexmt) {
+        MPP_LOCK(mp->mp_mppcb);
+        /* XXXNJW: To simplify for now, though this does work.
+         * If mp_state > ESTABLISHED, let the MP RTO take care of
+         * re-sending DFINs */
+        if (mp->mp_state == MPS_M_ESTABLISHED) {
+			mp->ds_snd_nxt = lmax(mp_rexmit_dsn, mp->ds_snd_una);
+			printf("%s: data-level re-inject at %u\n", __func__,
+				(uint32_t) mp->ds_snd_nxt);
+        }
+		(void) mp_output(mp);
+		MPP_UNLOCK(mp->mp_mppcb);
+	}
+
 	CURVNET_RESTORE();
 }
 
diff -r 1d1c4c997b66 sys/netinet/tcp_timewait.c
--- a/sys/netinet/tcp_timewait.c	Tue Jul 07 20:31:09 2015 +0000
+++ b/sys/netinet/tcp_timewait.c	Sun Aug 30 14:27:42 2015 +1000
@@ -39,6 +39,7 @@
 #include <sys/param.h>
 #include <sys/systm.h>
 #include <sys/callout.h>
+#include <sys/kdb.h>
 #include <sys/kernel.h>
 #include <sys/sysctl.h>
 #include <sys/malloc.h>
@@ -47,6 +48,7 @@
 #include <sys/proc.h>
 #include <sys/socket.h>
 #include <sys/socketvar.h>
+#include <sys/taskqueue.h>
 #include <sys/protosw.h>
 #include <sys/random.h>
 
@@ -76,6 +78,8 @@
 #include <netinet/tcp_seq.h>
 #include <netinet/tcp_timer.h>
 #include <netinet/tcp_var.h>
+#include <netinet/mptcp_var.h>
+#include <netinet/mptcp_pcb.h>
 #ifdef INET6
 #include <netinet6/tcp6_var.h>
 #endif
@@ -220,6 +224,8 @@
 void
 tcp_twstart(struct tcpcb *tp)
 {
+	printf("%s\n", __func__);
+
 	struct tcptw *tw;
 	struct inpcb *inp = tp->t_inpcb;
 	int acknow;
@@ -276,6 +282,7 @@
 			return;
 		}
 	}
+
 	/*
 	 * The tcptw will hold a reference on its inpcb until tcp_twclose
 	 * is called
@@ -350,9 +357,11 @@
 		ACCEPT_LOCK();
 		SOCK_LOCK(so);
 		so->so_state &= ~SS_PROTOREF;
+		printf("%s: calling sofree with discarded tp %p\n", __func__, tp);
 		sofree(so);
 	} else
 		INP_WUNLOCK(inp);
+
 }
 
 /*
@@ -453,6 +462,8 @@
 void
 tcp_twclose(struct tcptw *tw, int reuse)
 {
+	printf("%s\n", __func__);
+
 	struct socket *so;
 	struct inpcb *inp;
 
@@ -508,6 +519,7 @@
 		in_pcbfree(inp);
 	}
 	TCPSTAT_INC(tcps_closed);
+
 }
 
 static int
